// g_combat.cpp

#include "g_local.h"

// set by G_Damage
Entity  *damage_attacker;
Entity  *damage_inflictor;

void Killed (Entity *self, Entity *inflictor, Entity *attacker /*, int damage, Vec3 point*/)
{
	if (self->health < -99)
		self->health = -99;

	if (self->movetype == MOVETYPE_PUSH || self->movetype == MOVETYPE_NONE)
	{       // doors, triggers, etc
		if (self->die)
			self->die (self, inflictor, attacker);
		return;
	}

// bump the monster counter
	if (self->flags & FL_MONSTER)
	{
//		killed_monsters = killed_monsters + 1;
//		WriteByte (MSG_ALL, SVC_KILLEDMONSTER);
	}

//	ClientObituary(self, attacker);

	// Tonik: a quick hack in place of ClientObituary...
	if (attacker->player) {
		if (self == attacker)
			self->frags--;
		else
			attacker->frags++;
	}
	
	self->takedamage = DAMAGE_NO;
	self->touch = NULL;
	self->effects = 0;

//	monster_death_use();

	if (self->die)
		self->die (self, inflictor, attacker);
	
}

/*
** The damage is coming from inflictor, but get mad at attacker
** This should be the only function that ever reduces health.
*/
void G_Damage (Entity *targ, Entity *inflictor, Entity *attacker, float damage, deathtype_t deathtype)
{
	Vec3	dir;
	float	save;
	float	take;

	if (!damage)
		return;

	if (!targ->takedamage)
		return;

// used by buttons and triggers to set activator for target firing
	damage_attacker = attacker;


// check for quad damage powerup on the attacker
/*	if (attacker->super_damage_finished > time && inflictor->classname != "door")
		if (deathmatch->value == 4)
			damage = damage * 8;
		else
			damage = damage * 4;
*/

// save damage based on the target's armor level

	save = ceil(targ->armortype*damage);
	if (save >= targ->armorvalue)
	{
		save = targ->armorvalue;
		targ->armortype = 0; 	// lost all armor
		targ->items &= ~(IT_ARMOR1 | IT_ARMOR2 | IT_ARMOR3);
	}
	
	targ->armorvalue = targ->armorvalue - save;
	take = ceil(damage-save);

// add to the damage total for clients, which will be sent as a single
// message at the end of the frame
// FIXME: remove after combining shotgun blasts?
	if (targ->player) {
		targ->dmg_take = targ->dmg_take + take;
		targ->dmg_save = targ->dmg_save + save;
	}

	damage_inflictor = inflictor;


// figure momentum add
	if ( inflictor && inflictor != world && (targ->movetype == MOVETYPE_WALK || targ->movetype == MOVETYPE_FLY) )
	{
		Vec3 dir = targ->origin - (inflictor->absmin + inflictor->absmax) * 0.5;
		Normalize (&dir);
		targ->velocity += dir * damage * 8;
	}


// check for godmode or invincibility
	if (targ->flags & FL_GODMODE)
		return;

/*	if (targ->invincible_finished >= time)
	{
		if (self->invincible_sound < time)
		{
			G_Sound (targ, CHAN_ITEM, "items/protect3.wav");
			self->invincible_sound = time + 2;
		}
		return;
	}

// team play damage avoidance
	attackerteam = infokey(attacker, "team");
	targteam = infokey(targ, "team");

	if ((teamplay == 1) && (targteam == attackerteam) &&
		(attacker.classname == "player") && (attackerteam != "") &&
		inflictor.classname !="door")
		return;

	if ((teamplay == 3) && (targteam == attackerteam) &&
		(attacker.classname == "player") && (attackerteam != "") &&
		(targ != attacker)&& inflictor.classname !="door")
		return;
*/
		
// do the damage
	targ->health -= take;

	if (targ->health <= 0) {
		Killed (targ, inflictor, attacker);
		return;
	}

// react to the damage
	if (targ->pain)
		targ->pain (targ, attacker);
}


/*
** Returns entities that have origins within a spherical area
*/
Entity *G_EntitiesInRadius (Entity *from, Vec3 &org, float rad)
{
	if (!from)
		from = g_edicts;
	else
		from++;

	for ( ; from < &g_edicts[globals.num_edicts] ; from++)
	{
		if (!from->inuse)
			continue;
		if (from->solid == SOLID_NOT)
			continue;
		Vec3 eorg = org - (from->origin + (from->mins + from->maxs) * 0.5);
		if (Length(eorg) > rad)
			continue;
		return from;
	}

	return NULL;
}

/*
** Returns true if the inflictor can directly damage the target.
** Used for explosions and melee attacks.
*/
bool CanDamage (Entity *targ, Entity *inflictor)
{
	Vec3	dest;
	trace_t	trace;

// bmodels need special checking because their origin is 0,0,0
	if (targ->movetype == MOVETYPE_PUSH)
	{
		dest = (targ->absmin + targ->absmax) * 0.5;
		trace = gi.trace (inflictor->origin, vec3_origin, vec3_origin, dest, MOVE_NOMONSTERS, inflictor);
		if (trace.fraction == 1.0)
			return true;
		if (trace.ent == targ)
			return true;
		return false;
	}
	
	trace = gi.trace (inflictor->origin, vec3_origin, vec3_origin, targ->origin, MOVE_NOMONSTERS, inflictor);
	if (trace.fraction == 1.0)
		return true;

	dest = targ->origin;
	dest[0] += 15.0;
	dest[1] += 15.0;
	trace = gi.trace (inflictor->origin, vec3_origin, vec3_origin, dest, MOVE_NOMONSTERS, inflictor);
	if (trace.fraction == 1.0)
		return true;

	dest = targ->origin;
	dest[0] += 15.0;
	dest[1] -= 15.0;
	trace = gi.trace (inflictor->origin, vec3_origin, vec3_origin, dest, MOVE_NOMONSTERS, inflictor);
	if (trace.fraction == 1.0)
		return true;

	dest = targ->origin;
	dest[0] -= 15.0;
	dest[1] += 15.0;
	trace = gi.trace (inflictor->origin, vec3_origin, vec3_origin, dest, MOVE_NOMONSTERS, inflictor);
	if (trace.fraction == 1.0)
		return true;

	dest = targ->origin;
	dest[0] -= 15.0;
	dest[1] -= 15.0;
	trace = gi.trace (inflictor->origin, vec3_origin, vec3_origin, dest, MOVE_NOMONSTERS, inflictor);
	if (trace.fraction == 1.0)
		return true;

	return false;
}

/*
** G_RadiusDamage
*/
void G_RadiusDamage (Entity *inflictor, Entity *attacker, float damage, Entity *ignore,
					 deathtype_t deathtype)
{
	Entity *ent = NULL;
	
	while ((ent = G_EntitiesInRadius(ent, inflictor->origin, damage + 40)) != NULL)
	{
		if (ent == ignore)
			continue;
		if (!ent->takedamage)
			continue;
		
		Vec3 org = ent->origin + (ent->mins + ent->maxs) * 0.5;
		float points = 0.5 * Length(inflictor->origin - org);
		if (points < 0)
			points = 0;
		points = damage - points;
		
		if (ent == attacker)
			points = points * 0.5;

		if (points > 0) {
			if (CanDamage (ent, inflictor)) {
				G_Damage (ent, inflictor, attacker, points, deathtype);
			}
		}
	}
}
